//#New(backend):                                                 //- YnK[s [Y]
    //#Init_Base:                                                    //- bݵ{ɶ}owҰʮɪѼ
    //#Init_Include:                                                 //- lƮɶǤJ禡 (iϥLoop_Base)
    //#Loop_Base:                                                    //- Loop}lɱҰʪ禡AæbĲoƥɱҰʦ^I
    //#Loop1_Event:                                                  //- bLoopʬݪƥ
    //#Loop1_Config: SubVoid_Void  0 DataAvailableSub                //- ҫإߦ^IѼ: CallbackType EndPar callbacksub
    //#Loop2_Event:                                                  //- bLoopʬݪƥ
    //#Loop2_Config: SubVoid_Void  0 DataAvailableSub                //- ҫإߦ^IѼ: CallbackType EndPar callbacksub
    //#Loop3_Event:                                                  //- bLoopʬݪƥ
    //#Loop3_Config: SubVoid_Void  0 DataAvailableSub                //- ҫإߦ^IѼ: CallbackType EndPar callbacksub
    //#CallBack1_Base:                                               //- Arduino^I
    //#CallBack1_Config: SubVoid_BArray 0 MessageArrivedSub          //- ^I Par1 EndPar callbacksub
    //#CallBack2_Base:                                               //- Arduino^I
    //#CallBack2_Config: SubVoid_StringBArray 0 2 NewMessageSub      //- ^I Par1 Par2 EndPar callbacksub
    //#CallBack3_Base:                                               //- Arduino^I
    //#CallBack3_Config: SubVoid_StringBArray 0 2 NewMessageSub      //- ^I Par1 Par2 EndPar callbacksub
    //#
#pragma once
#include "B4RDefines.h"
#include "Stickc.h"

    //~Event: 
    //~Version: 1.0 
    //~Author - 
    //~Libray from Arduino

namespace B4R {
    //~shortname:M5STICKC 
    class B4RSTICKC 
    {
        private:
            STICKC stickc;
        public:
            void begin(bool LCDEnable, bool PowerEnable, bool SerialEnable);
            void update();
            int16_t height();
            int16_t width();
            void setRotation(byte r);
            void fillScreen(uint32_t color);
            void drawPixel(int32_t x, int32_t y, uint32_t color);
            void drawLine(int32_t x0, int32_t y0, int32_t x1, int32_t y1, uint32_t color);
            void fillRect(int32_t x, int32_t y, int32_t w, int32_t h, uint32_t color);
            void drawRect(int32_t x, int32_t y, int32_t w, int32_t h, uint32_t color);
            void drawRoundRect(int32_t x0, int32_t y0, int32_t w, int32_t h, int32_t radius, uint32_t color);
            void fillRoundRect(int32_t x0, int32_t y0, int32_t w, int32_t h, int32_t radius, uint32_t color);
            void drawCircle(int32_t x0, int32_t y0, int32_t r, uint32_t color);
            void fillCircle(int32_t x0, int32_t y0, int32_t r, uint32_t color);
            void drawEllipse(int16_t x0, int16_t y0, int32_t rx, int32_t ry, uint16_t color);
            void fillEllipse(int16_t x0, int16_t y0, int32_t rx, int32_t ry, uint16_t color);
            void drawTriangle(int32_t x0, int32_t y0, int32_t x1, int32_t y1, int32_t x2, int32_t y2, uint32_t color);
            void fillTriangle(int32_t x0, int32_t y0, int32_t x1, int32_t y1, int32_t x2, int32_t y2, uint32_t color);
            void setCursor(int16_t x, int16_t y);
            void setTextColor(uint16_t fgcolor, uint16_t bgcolor);
            void setTextSize(byte size);
			void setTextFont(byte font);
			uint16_t color565(byte red, byte green, byte blue);
            void print(B4RString* str);
			void drawString(B4RString* string, int32_t poX, int32_t poY);
            void backlit(byte brightness);
            void AXP_DisableAllIRQ();
            void AXP_ClearAllIRQ();
            void AXP_EnablePressIRQ(bool short_press, bool long_press);
            void AXP_GetPressIRQ(ArrayByte* short_press, ArrayByte* long_press);
            void AXP_ClearPressIRQ(bool short_press, bool long_press);
            void AXP_SetSleep();
            void AXP_DeepSleep(ulong time_in_us);
            void AXP_LightSleep(ulong time_in_us);
            void AXP_SetChargeVoltage(byte v);
            void AXP_SetChargeCurrent(byte c);
            void AXP_SetVOff(byte voltage);
            float AXP_GetBatVoltage();
            float AXP_GetBatCurrent();
            float AXP_GetVinVoltage();
            float AXP_GetVinCurrent();
            float AXP_GetVBusVoltage();
            float AXP_GetVBusCurrent();
            float AXP_GetBatPower();
            void PowerOff();
            void LED_On();
            void LED_Off();
            byte LED_getStatus();
            byte IMU_Init();
            void IMU_getAccelAdc(ArrayInt* ax, ArrayInt* ay, ArrayInt* az);
            void IMU_getGyroAdc(ArrayInt* gx, ArrayInt* gy, ArrayInt* gz);
            void IMU_getTempAdc(ArrayInt* t);
            void IMU_getAccelData(ArrayFloat* ax, ArrayFloat* ay, ArrayFloat* az);
            void IMU_getGyroData(ArrayFloat* gx, ArrayFloat* gy, ArrayFloat* gz);
            void IMU_getTempData(ArrayFloat* t);
            void IMU_getAhrsData(ArrayFloat* pitch, ArrayFloat* roll, ArrayFloat* yaw);
            void RTC_SetTime(byte Hours, byte Minutes, byte Seconds);
            void RTC_SetDate(byte WeekDay, byte Month, byte Date, uint16_t Year);
            void RTC_GetTime(ArrayByte* Hours, ArrayByte* Minutes, ArrayByte* Seconds);
            void RTC_GetDate(ArrayByte* WeekDay, ArrayByte* Month, ArrayByte* Date, ArrayUInt* Year);
            bool BtnA_isPressed();
            bool BtnA_isReleased();
            bool BtnA_wasPressed();
            bool BtnA_wasReleased();
            bool BtnA_pressedFor(uint32_t ms);
            bool BtnA_releasedFor(uint32_t ms);
            bool BtnA_wasReleasefor(uint32_t ms);
            bool BtnB_isPressed();
            bool BtnB_isReleased();
            bool BtnB_wasPressed();
            bool BtnB_wasReleased();
            bool BtnB_pressedFor(uint32_t ms);
            bool BtnB_releasedFor(uint32_t ms);
            bool BtnB_wasReleasefor(uint32_t ms);
			
			#define /*UInt COLOR_NAVY;*/ B4RM5STICKC_COLOR_NAVY TFT_NAVY 
			#define /*UInt COLOR_BLACK;*/ B4RM5STICKC_COLOR_BLACK TFT_BLACK 
			#define /*UInt COLOR_DARKGREEN;*/ B4RM5STICKC_COLOR_DARKGREEN TFT_DARKGREEN 
			#define /*UInt COLOR_DARKCYAN;*/ B4RM5STICKC_COLOR_DARKCYAN TFT_DARKCYAN 
			#define /*UInt COLOR_MAROON;*/ B4RM5STICKC_COLOR_MAROON TFT_MAROON 
			#define /*UInt COLOR_PURPLE;*/ B4RM5STICKC_COLOR_PURPLE TFT_PURPLE 
			#define /*UInt COLOR_OLIVE;*/ B4RM5STICKC_COLOR_OLIVE TFT_OLIVE 
			#define /*UInt COLOR_LIGHTGREY;*/ B4RM5STICKC_COLOR_LIGHTGREY TFT_LIGHTGREY 
			#define /*UInt COLOR_DARKGREY;*/ B4RM5STICKC_COLOR_DARKGREY TFT_DARKGREY
			#define /*UInt COLOR_BLUE;*/ B4RM5STICKC_COLOR_BLUE TFT_BLUE 
			#define /*UInt COLOR_GREEN;*/ B4RM5STICKC_COLOR_GREEN TFT_GREEN 
			#define /*UInt COLOR_CYAN;*/ B4RM5STICKC_COLOR_CYAN TFT_CYAN 
			#define /*UInt COLOR_RED;*/ B4RM5STICKC_COLOR_RED TFT_RED 
			#define /*UInt COLOR_MAGENTA;*/ B4RM5STICKC_COLOR_MAGENTA TFT_MAGENTA 
			#define /*UInt COLOR_YELLOW;*/ B4RM5STICKC_COLOR_YELLOW TFT_YELLOW 
			#define /*UInt COLOR_WHITE;*/ B4RM5STICKC_COLOR_WHITE TFT_WHITE 			
			#define /*UInt COLOR_ORANGE;*/ B4RM5STICKC_COLOR_ORANGE TFT_ORANGE 
			#define /*UInt COLOR_GREENYELLOW;*/ B4RM5STICKC_COLOR_GREENYELLOW TFT_GREENYELLOW 
			#define /*UInt COLOR_PINK;*/ B4RM5STICKC_COLOR_PINK TFT_PINK 
			#define /*UInt COLOR_NONE;*/ B4RM5STICKC_COLOR_NONE TFT_TRANSPARENT
    };
}
